#include <stdio.h>
#include <stdlib.h>

#ifndef MSDOS_TC
	#include <inttypes.h>
#endif

#ifdef MSDOS_TC
	#include <stddef.h>
#endif

# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# ifndef YYLMAX 
# define YYLMAX BUFSIZ
# endif 
#ifndef __cplusplus
# define output(c) (void)putc(c,yyout)
#else
# define lex_output(c) (void)putc(c,yyout)
#endif

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
	int yyback(int *, int);
	int yyinput(void);
	int yylook(void);
	void yyoutput(int);
	int yyracc(int);
	int yyreject(void);
	void yyunput(int);
	int yylex(void);
#ifdef YYLEX_E
	void yywoutput(wchar_t);
	wchar_t yywinput(void);
#endif
#ifndef yyless
	int yyless(int);
#endif
#ifndef yywrap
	int yywrap(void);
#endif
#ifdef LEXDEBUG
	void allprint(char);
	void sprint(char *);
#endif
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#ifdef __cplusplus
extern "C" {
#endif
	void exit(int);
#ifdef __cplusplus
}
#endif

#endif
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
#ifndef __cplusplus
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#else
# define lex_input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#endif
#define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng;
#define YYISARRAY
char yytext[YYLMAX];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin, *yyout;
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;


/* # line 6 "odl2.l" */
/*****************************************************************************

 Description: This file contains the lexical analyzer for the Object
              Description Language. The lexical analyzer is created
              using Lex and modifications to the lexical analysis of
              ODL should be made by modifying the Lex input file and
              not the C-language version of the analyzer produced by
              Lex.

 Author:  Randy Davis, University of Colorado LASP

 Creation Date: 17 April 1990
 Last Modified: 18 May 1991
 
 History:

   Creation - This routine was introduced in Version 1 of the ODLC library.

   Version 2.0 - 30 August 1990 - R. Davis, U. of Colorado LASP
     a) Upgraded to ODL Version 2.  The biggest change is the support
        of groups.  Support for ODL Version 1 features not found in
        Version 2 -- like the range operator -- remain so that the
        lexical analyzer can handle older labels as well as new ones.
     b) Added support for ODL Version 0 date and time format. 

   Version 2.1 - 13 March 1991 - R. Davis, U. of Colorado LASP
     a) Changed to a more general way to turn tokens into 'value data'
        structures by converting from the older ODLxToken routines to
        ODLConvertX routines.  Processing of string tokens was moved into
        a new action routine named yyGetStringToken.
     b) Added recognition of two values that are often entered incorrectly
        by users: file names without quotation marks (which are turned into
        strings); and the symbol N/A (for Not Applicable, which is turned 
        into a quoted symbol).
     c) Saved comments so they can be attached as annotation to the ODL tree.

  Version 2.2 - 18 May 1991 - M. DeMore, Jet Propulsion Laboratory
    Removed ODL function prototypes which are now in include files.
    Added include file odlinter.h.

  Version 2.3 - 13 October 1991 - M. DeMore, Jet Propulsion Laboratory
     Removed code in yyGetStringToken which used to process '\t' and
     `\n`.  They are now transferred exactly as is to the output string
     and are handled by the output routines instead.  This was done to
     prevent the lexer from eating backslashes in DOS file names.

  Version 2.4 - 8 July 1992 - M. DeMore, Jet Propulsion Laboratory
     Updated definition of name token to allow individual words to
     begin with letters.

  Version 2.5 - 17 Oct 2003 - D. Schultz, Jet Propulstion Laboratory
     Added the null_str token.  The recognized NULL patterns are -
     "NULL", 'NULL', NULL  
     The search order for these patterns are before a ' or " 
     so they are not interpreted as a name or symbol

******************************************************************************/


/* # line 64 "odl2.l" */
/*****************************************************************************
 To allow the use of the resulting file on multiple platforms, the following
 changes should be performed on the resulting C file after its generation
 by the Sun Version of Lex:

    1) Change the line
   
          # include "stdio.h" 

                to
  
          # include <stdio.h>

    2) Change the line
          
          # define YYTYPE int

                 to
          # define YYTYPE unsigned char

    3) Change the lines
          
          yyback(p, m)
              int *p;

              to
  
          yyback (p, m)
              int *p;
              int m;

    4) Change the line

          FILE *yyin = {stdin}, *yyout = {stdout};

               to

          FILE *yyin, *yyout;

*****************************************************************************/

#include "odldef.h"
#include "odlparse.h"
#include "odlinter.h"


/* # line 109 "odl2.l" */
/* This was moved from rdvalue.c so that other modules could be independent
   of rdvalue */

int nc;


/* # line 114 "odl2.l" */
/* The following are for the dynamic string allocation routines */

# define ODL_BUFF_INCREMENT BUFSIZ

int ODL_buf_pos = 0;
long ODL_buf_size = 0;
char *temp_buf = NULL;
char *ODL_buffer = NULL;



/* # line 124 "odl2.l" */
/* The following are warning messages */

#define MESSAGE1 "Value is assumed to be a file name -- converted to a string"
#define MESSAGE2 "Value N/A is not a name -- will appear within single quotes"
#define MESSAGE3 "BEGIN_GROUP statement found.  Will be converted to GROUP"
#define MESSAGE4 "BEGIN_OBJECT statement found.  Will be converted to OBJECT"


/* # line 131 "odl2.l" */
/* The following global variable is defined in the module containing the
   parser action routines */


/* # line 134 "odl2.l" */
/* The following global variable is defined in the module containing the
   parser action routines */

extern char       *ODLcurrent_comment;   /* Most recently recognized comment */


/* # line 139 "odl2.l" */
/* The following routine processes string tokens.  This routine is used
   because ODL strings can be very long, rendering LEX's regular
   expression mechanism for getting tokens inefficient */

char *yyGetStringToken ();


/* # line 145 "odl2.l" */
/* The following routine processes comments within an ODL label */

void  yyGetComment ();


# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
#ifdef __cplusplus
/* to avoid CC and lint complaining yyfussy not being used ...*/
static int __lex_hack = 0;
if (__lex_hack) goto yyfussy;
#endif
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:

/* # line 177 "odl2.l" */
                             {
                      
               return (_END);
                      
                                    }
break;
case 2:

/* # line 183 "odl2.l" */
                    {
                                     return (_END_GROUP);
                                    }
break;
case 3:

/* # line 187 "odl2.l" */
                   {
                                     return (_END_OBJECT);
                                    }
break;
case 4:

/* # line 191 "odl2.l" */
                            {
                                     return (_GROUP);
                                    }
break;
case 5:

/* # line 195 "odl2.l" */
                  {
                                     ODLPrintWarning(MESSAGE3);
                                     return (_GROUP);
                                    }
break;
case 6:

/* # line 200 "odl2.l" */
                           {
                                     return (_OBJECT);
                                    }
break;
case 7:

/* # line 204 "odl2.l" */
                 {
                                     ODLPrintWarning(MESSAGE4);
                                     return (_OBJECT);
                                    }
break;
case 8:

/* # line 209 "odl2.l" */
                           {
                                     yylval.item = 
                                        ODLConvertNull ("NULL", 4);
                                        return(_null_str);
                                    }
break;
case 9:

/* # line 215 "odl2.l" */
                           {
                                     yylval.item = 
                                        ODLConvertNull ("NULL", 4);
                                        return(_null_str);
                                    }
break;
case 10:

/* # line 221 "odl2.l" */
                           {
                                     yylval.item = 
                                        ODLConvertNull ("NULL", 4);
                                        return(_null_str);
                                    }
break;
case 11:

/* # line 227 "odl2.l" */
{
                                     yylval.item =
                                        ODLConvertSymbol (yytext, yyleng, 1);
                                     return (_name);
                                    }
break;
case 12:

/* # line 233 "odl2.l" */
                          {
                                     yylval.item =
                                       ODLConvertSymbol(&yytext[1],yyleng-2,2);
                                     return (_symbol);
                                    }
break;
case 13:

/* # line 239 "odl2.l" */
                                 {
                                     temp_buf = yyGetStringToken ();
                                     yylval.item = 
                                        ODLConvertString (temp_buf, 
                                              ODLStringLength ());
                                     ODLKillString ();
                                     return (_text_string);
                                    }
break;
case 14:

/* # line 248 "odl2.l" */
          {
                                       /* This is the low part of an ODL
                                          Version 1 range value */
                                     yylval.item =
                                        ODLConvertInteger (yytext, yyleng);
                                     return (_integer);
                                    }
break;
case 15:

/* # line 256 "odl2.l" */
               {
                                     yylval.item =
                                        ODLConvertInteger (yytext, yyleng);
                                     return (_integer);
                                    }
break;
case 16:

/* # line 262 "odl2.l" */
{
                                     yylval.item =
                                        ODLConvertInteger (yytext, yyleng);
                                     return (_integer);
                                    }
break;
case 17:

/* # line 269 "odl2.l" */
 {
                                     yylval.item = 
                                        ODLConvertReal (yytext, yyleng);
                                     return (_real);
                                    }
break;
case 18:

/* # line 275 "odl2.l" */
                             {
                                     yylval.item =
                                        ODLConvertDate (yytext, yyleng);
                                     return (_date);
                                    }
break;
case 19:

/* # line 281 "odl2.l" */
                           {
                                     yylval.item =
                                        ODLConvertDate (yytext, yyleng);
                                     return (_date);
                                    }
break;
case 20:

/* # line 287 "odl2.l" */
                    {
                                     yylval.item =
                                        ODLConvertTime (yytext, yyleng);
                                     return (_time);
                                    }
break;
case 21:

/* # line 293 "odl2.l" */
          {
                                     yylval.item =
                                        ODLConvertDateTime (yytext, yyleng);
                                     return (_date_time);
                                    }
break;
case 22:

/* # line 299 "odl2.l" */
                  {
                                     yylval.item =
                                        ODLConvertDateTime (yytext, yyleng);
                                     return (_date_timeV0);
                                    }
break;
case 23:

/* # line 305 "odl2.l" */
{
                                     ODLPrintWarning (MESSAGE1);
                                     yylval.item =
                                        ODLConvertString (yytext, yyleng);
                                     return (_text_string);
                                    }
break;
case 24:

/* # line 312 "odl2.l" */
                        {
                                     ODLPrintWarning (MESSAGE2);
                                     yylval.item =
                                        ODLConvertSymbol (yytext, yyleng, 2);
                                     return (_symbol);
                                    }
break;
case 25:

/* # line 319 "odl2.l" */
                                {
                                     return (_semi);
                                    }
break;
case 26:

/* # line 323 "odl2.l" */
                                {
                                     return (_sequence_opening);
                                    }
break;
case 27:

/* # line 327 "odl2.l" */
                                {
                                     return (_sequence_closing);
                                    }
break;
case 28:

/* # line 331 "odl2.l" */
                                {
                                     return (_set_opening);
                                    }
break;
case 29:

/* # line 335 "odl2.l" */
                                {
                                     return (_set_closing);
                                    }
break;
case 30:

/* # line 339 "odl2.l" */
                                {
                                     return (_units_opening);
                                    }
break;
case 31:

/* # line 343 "odl2.l" */
                                {
                                     return (_units_closing);
                                    }
break;
case 32:

/* # line 347 "odl2.l" */
                                {
                                     return (_list_separator);
                                    }
break;
case 33:

/* # line 351 "odl2.l" */
                                {
                                     return (_point_operator);
                                    }
break;
case 34:

/* # line 355 "odl2.l" */
                                {
                                     return (_assignment_operator);
                                    }
break;
case 35:

/* # line 359 "odl2.l" */
                                {
                                     return (_multiply_operator);
                                    }
break;
case 36:

/* # line 363 "odl2.l" */
                                {
                                     return (_divide_operator);
                                    }
break;
case 37:

/* # line 367 "odl2.l" */
                               {
                                     return (_exponentiate_operator);
                                    }
break;
case 38:

/* # line 371 "odl2.l" */
                               {
                                     return (_range_operator);
                                    }
break;
case 39:

/* # line 375 "odl2.l" */
               {
                                     /* This is a comment line */

                                     yyGetComment ();
                                    }
break;
case 40:

/* # line 381 "odl2.l" */
                             {
                                     /* This is a comment at the end of a
                                        line of ODL code -- ignore it */
                                    }
break;
case 41:

/* # line 386 "odl2.l" */
                       {}
break;
case 42:

/* # line 388 "odl2.l" */
                        {}
break;
case 43:

/* # line 390 "odl2.l" */
                                  { /* Return other characters verbatim */
                                     return (yytext[0]);
                                    }
break;
case -1:
break;
default:
(void)fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

/* # line 395 "odl2.l" */

/*****************************************************************************

  Routine: yywrap

  Description:  Required wrap-up routine for lexical processing.  No
                special wrap-up is required for ODL parsing.

  Input:  None.

  Output: Return value is set to TRUE to indicate parsing completed OK.

*****************************************************************************/

yywrap ()
{
 return(1);
}


/*****************************************************************************

  Routine: yyGetStringToken

  Description:  Get a text string token.  The opening delimiter (") was
                recognized by the lexical analyzer before this routine
                was called.  This routine will read in the remainder of
                the string token up to the end delimiter and it will
                reformat the text string as it goes into an ODL string
                value.

  Input:  No arguments required.  The text of the string token is gotten
          using the lexical analyzer input function (yyinput).

  Output: The text string is placed in the lexical analyzer's token buffer
          (pointed to by yytext) and the token character count (yyleng) is
          set to reflect the string length.

  MDD - October 22, 1991
        Modified to use dynamic memory allocation routines rather than
        a static array.

*****************************************************************************/

char *yyGetStringToken ()
{
  char    c;                       /* Current input character               */
  int     newline;                 /* New line flag:                        */
                                   /*   0 - Not at the start of a line      */
                                   /*  +1 - Newline found in input string   */
                                   /*  -1 - Newline placed in output string */

  newline = 1;

  ODLNewString();

  while ((c = yyinput()) != '"' && c != '\0')
   {
    switch (c)
     {
      case '\n':

       /* End of current line : get rid of any trailing blanks or CRs on the line */

       while (ODLPeekString (1) == ' ' || ODLPeekString (1) == '\r')
              ODLBackupString ();

       /* If the last non-blank character on the line is a '-', then this
          is a word hyphen and we can delete it. If it is an '&' then this
          indicates that all characters to the left are to be left intact,
          although we do delete the '&'.  Otherwise we add a blank to
          separate the last word on the current input line from the first
          word on the next input line. If there are two or more newlines
          in a row, then we retain the newlines to separate paragraphs */

       if (newline > 0)
       {
           if (ODLPeekString (1) &&
                  !(ODLPeekString (1) == 'n' && ODLPeekString (2) == '\\'))
           {
              ODLStoreString ('\\');
              ODLStoreString ('n');
           }
           ODLStoreString ('\\');
           ODLStoreString ('n');
       }
       else if (newline < 0)
       {
          newline = 1;
       }
       else
       {
           newline = 1;
           if (ODLPeekString (1) == '-' || ODLPeekString (1) == '&')
           {
              ODLBackupString ();
           }
           else if (ODLPeekString (1) &&
                    !(ODLPeekString (1) == 'n' && ODLPeekString (2) == '\\'))
           {
              ODLStoreString (' ');
           }
       }
       break;

      case ' ':  case '\t': case '\r':

       /* Ignore a blank or tab at the beginning of an input line; otherwise
          copy a blank character into the output string */

       if (newline == 0)
       {
         ODLStoreString (' ');
       }
       break;

      case '\\':
         ODLStoreString (c);
         ODLStoreString (yyinput ());
         if (ODLPeekString (1) == 'n' && ODLPeekString (2) == '\\')
            newline = -1;
         else if (ODLPeekString (1) &&
              !(ODLPeekString (1) == 't' && ODLPeekString (2) == '\\'))
            newline = 0;
         break;

      default:

       /* Copy the input character to the token buffer */
       ODLStoreString (c);
       newline = 0;

     }
   }

  /* Terminate the token buffer */

  return (ODLStoreString ('\0'));
}


/*****************************************************************************

  Routine: yyGetComment

  Description:  Get a comment and either attach it to the ODL tree or
                put it where other routines can get at it and do so.

  Input:  No arguments required.  The text and length of the comment
          come from the global variables yyinput and yyleng.

  Output: No output parameters.  The comment is copied and saved for
          later processing.

*****************************************************************************/


void yyGetComment ()
{
  int   ib;                   /* Index to first character in comment text   */
  int   ie;                   /* Index to last character in comment text    */
  int   il;                   /* Count of characters in comment text        */
  char *string;               /* Pointer to space allocated for comment     */
  int temp_end;

#include  <ctype.h>


  /* Skip over any whitespace prior to the start of the comment */

  ib = 0;
  ie = yyleng - 1;

  for ( ; ib <= ie && isspace (yytext[ib]) ; ib++);

  /* Skip over the slash and asterisk that introduce the comment */

  ib += 2;

  /* Eliminate any trailing whitespace */

  for ( ; ie >= ib && isspace (yytext[ie]); ie--);

  /* Eliminate any trailing characters */

  for (temp_end = ie; temp_end > ib && yytext[temp_end] != '/'; temp_end--);
  if (yytext [temp_end] == '/' && yytext [temp_end - 1] == '*')
  {
     if (temp_end != ie)
     {
        ie = temp_end;
        ODLPrintWarning ("Characters found on line after comment ignored");
     }
  }

  /* Skip backward over ending comment delimiter */

  if (ie > ib && yytext[ie] == '/')
    {
      if (yytext[ie-1] == '*')
        {
          ie -= 2;
        }
    }

  /* Eliminate any trailing whitespace */

/*  for ( ; ie >= ib && isspace (yytext[ie]); ie--); */

  /* Get the number of characters in the comment string */

  yytext[ie+1] = '\0';
  il = (ie >= ib)? ie-ib+1 : 0;

  if (ODLcurrent_comment == NULL)
    {
      /* There is no comment currently.  Allocate space for a new
         comment and copy the text */

      string = (char *) malloc (il+1);
      if (string != NULL)
        {
          ODLcurrent_comment = strcpy (string, &yytext[ib]);
        }
    }
  else
    {
      /* There is already some comment there: put in a newline character
         to end the previous comment line and append the current text
         to the comment */

      string = (char *) realloc (ODLcurrent_comment,
                                 strlen (ODLcurrent_comment)+il+2);
      if (string != NULL)
        {
          strcat (string, "\n");
          ODLcurrent_comment = strcat (string, &yytext[ib]);
        }
    }

return;
}


char *ODLStoreString (c)
char c;
{
   if (ODL_buffer != NULL)
   {
      if (ODL_buf_pos < ODL_buf_size)
         *(ODL_buffer + ODL_buf_pos++) = c;
      else
      {
         ODL_buf_size = ODL_buf_size + ODL_BUFF_INCREMENT;
         ODL_buffer = (char *) realloc (ODL_buffer, ODL_buf_size);
         if (ODL_buffer == NULL)
         {
            printf ("Out of memory for string storage.");
            exit (1);
         }
         *(ODL_buffer + ODL_buf_pos++) = c;
      }
   }
   return (ODL_buffer);
}

char *ODLNewString ()
{
   ODLKillString ();
   ODL_buffer = (char *) malloc (ODL_BUFF_INCREMENT);
   if (ODL_buffer == NULL)
   {
      printf ("Out of memory for string storage.");
      exit (1);
   }
   ODL_buf_size = ODL_BUFF_INCREMENT;
}

char ODLBackupString ()
{
   if (ODL_buf_pos > 0)
   {
       ODL_buf_pos--;
       return (*(ODL_buffer + ODL_buf_pos));
   }
   else
      return (0);
}

char ODLPeekString (pos)
int pos;
{
   if (pos != 0 && ODL_buffer != NULL && pos <= ODL_buf_pos)
      return (*(ODL_buffer + (ODL_buf_pos - pos)));
   else
      return (0);
}

void ODLKillString ()
{
   if (ODL_buffer != NULL) free (ODL_buffer);
   ODL_buffer = NULL;
   ODL_buf_pos = 0;
   ODL_buf_size = 0;
}

int ODLStringLength ()
{
   return (ODL_buf_pos - 1);
}
int yyvstop[] = {
0,

43,
0, 

41,
43,
0, 

42,
0, 

42,
43,
0, 

13,
43,
0, 

43,
0, 

26,
43,
0, 

27,
43,
0, 

35,
43,
0, 

43,
0, 

32,
43,
0, 

43,
0, 

36,
43,
0, 

15,
43,
-14,
0, 

25,
43,
0, 

30,
43,
0, 

34,
43,
0, 

31,
43,
0, 

11,
43,
0, 

11,
43,
0, 

11,
43,
0, 

11,
43,
0, 

11,
43,
0, 

11,
43,
0, 

33,
43,
0, 

11,
43,
0, 

28,
43,
0, 

29,
43,
0, 

41,
43,
0, 

36,
43,
0, 

12,
0, 

37,
0, 

15,
-14,
0, 

38,
0, 

17,
0, 

40,
0, 

17,
0, 

15,
-14,
0, 

23,
0, 

11,
0, 

11,
0, 

11,
0, 

11,
0, 

11,
0, 

11,
0, 

39,
40,
0, 

18,
0, 

14,
0, 

17,
0, 

19,
0, 

20,
0, 

11,
0, 

11,
0, 

1,
11,
0, 

11,
0, 

24,
0, 

11,
0, 

11,
0, 

39,
0, 

17,
0, 

16,
0, 

20,
0, 

11,
0, 

11,
0, 

8,
11,
0, 

11,
0, 

17,
0, 

18,
0, 

19,
0, 

20,
0, 

20,
0, 

11,
0, 

11,
0, 

11,
0, 

4,
11,
0, 

11,
0, 

10,
0, 

9,
12,
0, 

20,
0, 

20,
0, 

11,
0, 

11,
0, 

6,
11,
0, 

21,
0, 

22,
0, 

20,
0, 

11,
0, 

11,
0, 

11,
0, 

11,
0, 

21,
0, 

11,
0, 

11,
0, 

11,
0, 

11,
0, 

21,
0, 

21,
0, 

22,
0, 

11,
0, 

11,
0, 

2,
11,
0, 

11,
0, 

21,
0, 

21,
0, 

22,
0, 

22,
0, 

11,
0, 

11,
0, 

3,
11,
0, 

21,
0, 

5,
11,
0, 

11,
0, 

7,
11,
0, 
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
1,6,	0,0,	31,59,	0,0,	
0,0,	0,0,	36,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
63,0,	100,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,7,	
0,0,	31,59,	66,85,	99,114,	
1,8,	1,9,	1,10,	1,11,	
1,12,	1,13,	11,37,	1,14,	
1,15,	1,16,	15,42,	28,56,	
31,60,	25,56,	32,61,	39,45,	
60,80,	70,88,	100,115,	70,89,	
1,17,	1,18,	1,19,	1,20,	
103,116,	2,31,	1,21,	1,22,	
1,21,	1,21,	1,23,	1,21,	
1,24,	1,21,	1,21,	1,21,	
22,53,	26,58,	41,64,	1,25,	
1,26,	1,21,	7,33,	1,21,	
57,78,	1,21,	1,21,	23,54,	
33,62,	24,55,	2,7,	25,57,	
62,81,	36,63,	63,82,	1,27,	
2,9,	2,10,	2,11,	75,95,	
2,13,	78,97,	2,14,	2,32,	
67,86,	81,99,	102,87,	104,117,	
22,53,	26,58,	41,64,	1,28,	
53,74,	54,75,	55,76,	2,17,	
2,18,	2,19,	2,20,	23,54,	
8,34,	24,55,	56,77,	58,79,	
1,29,	36,34,	1,30,	74,94,	
8,34,	8,0,	8,34,	12,38,	
105,88,	12,39,	12,39,	12,39,	
12,39,	12,39,	12,39,	12,39,	
12,39,	12,39,	12,39,	67,87,	
53,74,	54,75,	55,76,	106,118,	
76,96,	71,90,	2,27,	71,90,	
82,0,	109,121,	56,77,	58,79,	
126,135,	140,149,	8,35,	74,94,	
144,153,	0,0,	8,34,	79,98,	
71,91,	0,0,	2,28,	8,34,	
38,41,	38,41,	38,41,	38,41,	
38,41,	38,41,	38,41,	38,41,	
38,41,	38,41,	0,0,	2,29,	
76,96,	2,30,	0,0,	0,0,	
8,34,	8,34,	8,34,	8,34,	
8,34,	8,34,	8,34,	8,34,	
8,34,	8,34,	94,109,	79,98,	
71,92,	8,36,	8,34,	8,34,	
0,0,	8,34,	0,0,	8,34,	
8,34,	14,40,	0,0,	14,41,	
14,41,	14,41,	14,41,	14,41,	
14,41,	14,41,	14,41,	14,41,	
14,41,	0,0,	82,100,	0,0,	
16,43,	0,0,	0,0,	0,0,	
0,0,	96,112,	94,109,	98,113,	
110,122,	8,34,	16,44,	16,45,	
16,46,	16,47,	16,47,	16,47,	
16,47,	16,47,	16,47,	16,47,	
16,47,	16,47,	16,47,	16,48,	
21,49,	0,0,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,51,	96,112,	111,123,	98,113,	
110,122,	0,0,	113,124,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	0,0,	111,123,	0,0,	
122,130,	21,52,	113,124,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	21,50,	21,50,	21,50,	
21,50,	34,34,	0,0,	108,90,	
122,130,	108,90,	108,120,	0,0,	
123,131,	34,34,	34,0,	34,34,	
44,67,	44,67,	44,67,	44,67,	
44,67,	44,67,	44,67,	44,67,	
44,67,	44,67,	0,0,	0,0,	
128,136,	129,137,	45,68,	130,138,	
45,69,	45,69,	45,69,	45,69,	
45,69,	45,69,	45,69,	45,69,	
45,69,	45,69,	0,0,	34,35,	
123,131,	0,0,	119,90,	34,34,	
119,90,	42,42,	0,0,	0,0,	
34,34,	45,64,	108,92,	0,0,	
0,0,	42,42,	42,0,	42,42,	
128,136,	129,137,	131,139,	130,138,	
125,132,	0,0,	125,132,	0,0,	
0,0,	34,34,	34,34,	34,34,	
34,34,	34,34,	34,34,	34,34,	
34,34,	34,34,	34,34,	125,133,	
136,145,	0,0,	34,34,	34,34,	
34,34,	45,64,	34,34,	42,42,	
34,34,	34,34,	0,0,	42,42,	
137,146,	119,92,	131,139,	0,0,	
42,42,	46,70,	46,70,	46,70,	
46,70,	46,70,	46,70,	46,70,	
46,70,	46,70,	46,70,	0,0,	
0,0,	0,0,	0,0,	125,134,	
136,145,	42,42,	42,42,	42,42,	
42,42,	42,42,	42,42,	42,42,	
42,42,	42,42,	42,42,	0,0,	
137,146,	0,0,	42,42,	42,42,	
42,42,	43,65,	42,42,	43,65,	
42,42,	42,42,	43,66,	43,66,	
43,66,	43,66,	43,66,	43,66,	
43,66,	43,66,	43,66,	43,66,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	138,147,	43,66,	
43,66,	43,66,	43,66,	43,66,	
43,66,	48,71,	48,71,	48,71,	
48,71,	48,71,	48,71,	48,71,	
48,71,	48,71,	48,71,	0,0,	
142,132,	0,0,	142,132,	142,151,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	138,147,	43,66,	
43,66,	43,66,	43,66,	43,66,	
43,66,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	142,134,	
0,0,	0,0,	0,0,	49,49,	
0,0,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	49,49,	
49,49,	49,49,	49,49,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	0,0,	139,148,	150,132,	
0,0,	150,132,	0,0,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	51,72,	51,72,	51,72,	
51,72,	52,49,	139,148,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	0,0,	145,154,	146,155,	
148,156,	154,158,	150,134,	155,159,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	145,154,	146,155,	
148,156,	154,158,	52,73,	155,159,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	52,50,	52,50,	
52,50,	52,50,	61,61,	0,0,	
0,0,	0,0,	0,0,	159,160,	
0,0,	0,0,	61,61,	61,0,	
61,61,	64,83,	0,0,	64,83,	
0,0,	0,0,	64,84,	64,84,	
64,84,	64,84,	64,84,	64,84,	
64,84,	64,84,	64,84,	64,84,	
0,0,	69,69,	69,69,	69,69,	
69,69,	69,69,	69,69,	69,69,	
69,69,	69,69,	69,69,	159,160,	
61,61,	0,0,	0,0,	0,0,	
61,61,	0,0,	0,0,	0,0,	
0,0,	61,61,	69,64,	72,72,	
72,72,	72,72,	72,72,	72,72,	
72,72,	72,72,	72,72,	72,72,	
72,72,	0,0,	0,0,	0,0,	
0,0,	0,0,	61,61,	61,61,	
61,61,	61,61,	61,61,	61,61,	
61,61,	61,61,	61,61,	61,61,	
0,0,	0,0,	0,0,	61,61,	
61,61,	61,61,	69,64,	61,61,	
0,0,	61,61,	61,61,	65,66,	
65,66,	65,66,	65,66,	65,66,	
65,66,	65,66,	65,66,	65,66,	
65,66,	0,0,	72,93,	0,0,	
0,0,	0,0,	0,0,	0,0,	
65,66,	65,66,	65,66,	65,66,	
65,66,	65,66,	83,101,	83,101,	
83,101,	83,101,	83,101,	83,101,	
83,101,	83,101,	83,101,	83,101,	
0,0,	0,0,	0,0,	0,0,	
0,0,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	0,0,	
65,66,	65,66,	65,66,	65,66,	
65,66,	65,66,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
73,73,	73,73,	73,73,	73,73,	
80,80,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
80,80,	80,0,	80,80,	84,84,	
84,84,	84,84,	84,84,	84,84,	
84,84,	84,84,	84,84,	84,84,	
84,84,	86,102,	86,102,	86,102,	
86,102,	86,102,	86,102,	86,102,	
86,102,	86,102,	86,102,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	80,80,	0,0,	
0,0,	0,0,	80,80,	0,0,	
0,0,	0,0,	0,0,	80,80,	
87,103,	87,103,	87,103,	87,103,	
87,103,	87,103,	87,103,	87,103,	
87,103,	87,103,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
80,80,	80,80,	80,80,	80,80,	
80,80,	80,80,	80,80,	80,80,	
80,80,	80,80,	0,0,	0,0,	
0,0,	80,80,	80,80,	80,80,	
0,0,	80,80,	0,0,	80,80,	
80,80,	88,104,	88,104,	88,104,	
88,104,	88,104,	88,104,	88,104,	
88,104,	88,104,	88,104,	89,105,	
89,105,	89,105,	89,105,	89,105,	
89,105,	89,105,	89,105,	89,105,	
89,105,	90,106,	90,106,	90,106,	
90,106,	90,106,	90,106,	90,106,	
90,106,	90,106,	90,106,	91,107,	
0,0,	91,108,	91,108,	91,108,	
91,108,	91,108,	91,108,	91,108,	
91,108,	91,108,	91,108,	93,72,	
93,72,	93,72,	93,72,	93,72,	
93,72,	93,72,	93,72,	93,72,	
93,72,	95,110,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	95,111,	107,119,	107,119,	
107,119,	107,119,	107,119,	107,119,	
107,119,	107,119,	107,119,	107,119,	
116,125,	116,125,	116,125,	116,125,	
116,125,	116,125,	116,125,	116,125,	
116,125,	116,125,	0,0,	0,0,	
0,0,	95,110,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	95,111,	117,126,	117,126,	
117,126,	117,126,	117,126,	117,126,	
117,126,	117,126,	117,126,	117,126,	
118,127,	118,127,	118,127,	118,127,	
118,127,	118,127,	118,127,	118,127,	
118,127,	118,127,	120,90,	0,0,	
120,90,	0,0,	0,0,	120,120,	
120,120,	120,120,	120,120,	120,120,	
120,120,	120,120,	120,120,	120,120,	
120,120,	0,0,	121,128,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	121,129,	132,140,	
132,140,	132,140,	132,140,	132,140,	
132,140,	132,140,	132,140,	132,140,	
132,140,	133,141,	0,0,	133,142,	
133,142,	133,142,	133,142,	133,142,	
133,142,	133,142,	133,142,	133,142,	
133,142,	120,92,	121,128,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	135,143,	121,129,	135,144,	
135,144,	135,144,	135,144,	135,144,	
135,144,	135,144,	135,144,	135,144,	
135,144,	141,150,	141,150,	141,150,	
141,150,	141,150,	141,150,	141,150,	
141,150,	141,150,	141,150,	143,152,	
143,152,	143,152,	143,152,	143,152,	
143,152,	143,152,	143,152,	143,152,	
143,152,	149,157,	149,157,	149,157,	
149,157,	149,157,	149,157,	149,157,	
149,157,	149,157,	149,157,	151,132,	
0,0,	151,132,	0,0,	0,0,	
151,151,	151,151,	151,151,	151,151,	
151,151,	151,151,	151,151,	151,151,	
151,151,	151,151,	153,153,	153,153,	
153,153,	153,153,	153,153,	153,153,	
153,153,	153,153,	153,153,	153,153,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	151,134,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-56,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+0,	0,		yyvstop+8,
yycrank+4,	0,		yyvstop+11,
yycrank+-119,	0,		yyvstop+14,
yycrank+0,	0,		yyvstop+16,
yycrank+0,	0,		yyvstop+19,
yycrank+4,	0,		yyvstop+22,
yycrank+85,	0,		yyvstop+25,
yycrank+0,	0,		yyvstop+27,
yycrank+159,	0,		yyvstop+30,
yycrank+8,	0,		yyvstop+32,
yycrank+185,	0,		yyvstop+35,
yycrank+0,	0,		yyvstop+39,
yycrank+0,	0,		yyvstop+42,
yycrank+0,	0,		yyvstop+45,
yycrank+0,	0,		yyvstop+48,
yycrank+198,	0,		yyvstop+51,
yycrank+7,	yysvec+21,	yyvstop+54,
yycrank+9,	yysvec+21,	yyvstop+57,
yycrank+7,	yysvec+21,	yyvstop+60,
yycrank+6,	yysvec+21,	yyvstop+63,
yycrank+11,	yysvec+21,	yyvstop+66,
yycrank+0,	0,		yyvstop+69,
yycrank+4,	yysvec+21,	yyvstop+72,
yycrank+0,	0,		yyvstop+75,
yycrank+0,	0,		yyvstop+78,
yycrank+5,	0,		yyvstop+81,
yycrank+12,	0,		yyvstop+84,
yycrank+3,	0,		0,	
yycrank+-320,	0,		0,	
yycrank+0,	0,		yyvstop+87,
yycrank+-8,	yysvec+34,	0,	
yycrank+0,	0,		yyvstop+89,
yycrank+120,	0,		0,	
yycrank+9,	yysvec+12,	yyvstop+91,
yycrank+0,	0,		yyvstop+94,
yycrank+9,	yysvec+38,	yyvstop+96,
yycrank+-364,	0,		yyvstop+98,
yycrank+402,	0,		0,	
yycrank+284,	0,		0,	
yycrank+300,	0,		yyvstop+100,
yycrank+365,	0,		0,	
yycrank+0,	yysvec+16,	yyvstop+102,
yycrank+425,	0,		0,	
yycrank+440,	0,		yyvstop+105,
yycrank+0,	yysvec+21,	yyvstop+107,
yycrank+498,	0,		0,	
yycrank+575,	0,		0,	
yycrank+41,	yysvec+21,	yyvstop+109,
yycrank+45,	yysvec+21,	yyvstop+111,
yycrank+35,	yysvec+21,	yyvstop+113,
yycrank+57,	0,		0,	
yycrank+8,	yysvec+21,	yyvstop+115,
yycrank+49,	yysvec+21,	yyvstop+117,
yycrank+0,	yysvec+31,	0,	
yycrank+14,	0,		0,	
yycrank+-697,	0,		yyvstop+119,
yycrank+16,	0,		0,	
yycrank+-18,	yysvec+34,	0,	
yycrank+666,	0,		0,	
yycrank+735,	0,		0,	
yycrank+3,	yysvec+65,	0,	
yycrank+59,	yysvec+44,	yyvstop+122,
yycrank+0,	0,		yyvstop+124,
yycrank+677,	0,		yyvstop+126,
yycrank+12,	yysvec+46,	yyvstop+128,
yycrank+106,	yysvec+48,	yyvstop+130,
yycrank+699,	yysvec+51,	yyvstop+132,
yycrank+773,	yysvec+52,	0,	
yycrank+54,	yysvec+21,	yyvstop+134,
yycrank+4,	yysvec+21,	yyvstop+136,
yycrank+63,	yysvec+21,	yyvstop+139,
yycrank+0,	0,		yyvstop+141,
yycrank+25,	yysvec+21,	yyvstop+143,
yycrank+94,	yysvec+21,	yyvstop+145,
yycrank+-895,	0,		yyvstop+147,
yycrank+29,	0,		0,	
yycrank+-142,	yysvec+34,	0,	
yycrank+758,	0,		0,	
yycrank+859,	0,		yyvstop+149,
yycrank+0,	0,		yyvstop+151,
yycrank+869,	0,		0,	
yycrank+896,	0,		0,	
yycrank+933,	0,		0,	
yycrank+943,	0,		0,	
yycrank+953,	0,		0,	
yycrank+965,	0,		0,	
yycrank+0,	0,		yyvstop+153,
yycrank+975,	yysvec+51,	0,	
yycrank+116,	yysvec+21,	yyvstop+155,
yycrank+962,	yysvec+52,	0,	
yycrank+145,	yysvec+21,	yyvstop+157,
yycrank+0,	yysvec+21,	yyvstop+159,
yycrank+160,	yysvec+21,	yyvstop+162,
yycrank+5,	0,		0,	
yycrank+-19,	yysvec+34,	0,	
yycrank+0,	yysvec+83,	yyvstop+164,
yycrank+22,	yysvec+86,	yyvstop+166,
yycrank+6,	yysvec+87,	0,	
yycrank+49,	yysvec+88,	0,	
yycrank+87,	yysvec+89,	yyvstop+168,
yycrank+89,	yysvec+90,	yyvstop+170,
yycrank+994,	0,		0,	
yycrank+280,	yysvec+91,	yyvstop+172,
yycrank+58,	yysvec+21,	yyvstop+174,
yycrank+146,	yysvec+21,	yyvstop+176,
yycrank+192,	yysvec+21,	yyvstop+178,
yycrank+0,	yysvec+21,	yyvstop+180,
yycrank+178,	yysvec+21,	yyvstop+183,
yycrank+0,	0,		yyvstop+185,
yycrank+0,	0,		yyvstop+187,
yycrank+1004,	0,		0,	
yycrank+1026,	0,		0,	
yycrank+1036,	0,		0,	
yycrank+319,	yysvec+107,	yyvstop+190,
yycrank+1051,	0,		yyvstop+192,
yycrank+1039,	yysvec+52,	0,	
yycrank+213,	yysvec+21,	yyvstop+194,
yycrank+254,	yysvec+21,	yyvstop+196,
yycrank+0,	yysvec+21,	yyvstop+198,
yycrank+337,	yysvec+116,	yyvstop+201,
yycrank+98,	yysvec+117,	yyvstop+203,
yycrank+0,	yysvec+118,	yyvstop+205,
yycrank+262,	yysvec+21,	yyvstop+207,
yycrank+279,	yysvec+21,	yyvstop+209,
yycrank+262,	yysvec+21,	yyvstop+211,
yycrank+309,	yysvec+21,	yyvstop+213,
yycrank+1071,	0,		0,	
yycrank+1083,	0,		0,	
yycrank+0,	0,		yyvstop+215,
yycrank+1103,	0,		0,	
yycrank+317,	yysvec+21,	yyvstop+217,
yycrank+334,	yysvec+21,	yyvstop+219,
yycrank+386,	yysvec+21,	yyvstop+221,
yycrank+523,	yysvec+21,	yyvstop+223,
yycrank+99,	yysvec+132,	yyvstop+225,
yycrank+1113,	0,		0,	
yycrank+441,	yysvec+133,	yyvstop+227,
yycrank+1123,	0,		0,	
yycrank+114,	yysvec+135,	yyvstop+229,
yycrank+549,	yysvec+21,	yyvstop+231,
yycrank+566,	yysvec+21,	yyvstop+233,
yycrank+0,	yysvec+21,	yyvstop+235,
yycrank+552,	yysvec+21,	yyvstop+238,
yycrank+1133,	0,		0,	
yycrank+548,	yysvec+141,	yyvstop+240,
yycrank+1148,	0,		yyvstop+242,
yycrank+0,	yysvec+143,	yyvstop+244,
yycrank+1158,	0,		yyvstop+246,
yycrank+557,	yysvec+21,	yyvstop+248,
yycrank+572,	yysvec+21,	yyvstop+250,
yycrank+0,	yysvec+21,	yyvstop+252,
yycrank+0,	yysvec+149,	yyvstop+255,
yycrank+0,	yysvec+21,	yyvstop+257,
yycrank+619,	yysvec+21,	yyvstop+260,
yycrank+0,	yysvec+21,	yyvstop+262,
0,	0,	0};
struct yywork *yytop = yycrank+1238;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
  0,   1,   1,   1,   1,   1,   1,   1, 
  1,   9,  10,  11,  11,  11,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  9,   1,   1,   1,   1,   1,   1,  39, 
  1,   1,   1,  43,   1,  43,   1,   1, 
 48,  48,  48,  48,  48,  48,  48,  48, 
 48,  48,   1,   1,   1,   1,   1,   1, 
  1,  65,  66,  67,  68,  69,  70,  71, 
 72,  73,  74,  72,  72,  72,  78,  79, 
 80,  72,  82,  72,  84,  85,  72,  72, 
 72,  72,  72,   1,   1,   1,   1,   1, 
  1,  65,  66,  67,  68,  69,  70,  71, 
 72,  73,  74,  72,  72,  72,  78,  79, 
 80,  72,  82,  72,  84,  85,  72,  72, 
 72,  72,  72,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,1,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*	Copyright (c) 1989 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#pragma ident	"@(#)ncform	6.12	97/12/08 SMI"

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
#if defined(__cplusplus) || defined(__STDC__)
int yylook(void)
#else
yylook()
#endif
{
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
#ifndef __cplusplus
			*yylastch++ = yych = input();
#else
			*yylastch++ = yych = lex_input();
#endif
#ifdef YYISARRAY
			if(yylastch > &yytext[YYLMAX]) {
				fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
				exit(1);
			}
#else
			if (yylastch >= &yytext[ yytextsz ]) {
				int	x = yylastch - yytext;

				yytextsz += YYTEXTSZINC;
				if (yytext == yy_tbuf) {
				    yytext = (char *) malloc(yytextsz);
				    memcpy(yytext, yy_tbuf, sizeof (yy_tbuf));
				}
				else
				    yytext = (char *) realloc(yytext, yytextsz);
				if (!yytext) {
				    fprintf(yyout,
					"Cannot realloc yytext\n");
				    exit(1);
				}
				yylastch = yytext + x;
			}
#endif
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (uintptr_t)yyt > (uintptr_t)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((uintptr_t)yyt < (uintptr_t)yycrank) {	/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
#ifndef __cplusplus
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
#else
		yyprevious = yytext[0] = lex_input();
		if (yyprevious>0)
			lex_output(yyprevious);
#endif
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
#if defined(__cplusplus) || defined(__STDC__)
int yyback(int *p, int m)
#else
yyback(p, m)
	int *p;
#endif
{
	if (p==0) return(0);
	while (*p) {
		if (*p++ == m)
			return(1);
	}
	return(0);
}
	/* the following are only used in the lex library */
#if defined(__cplusplus) || defined(__STDC__)
int yyinput(void)
#else
yyinput()
#endif
{
#ifndef __cplusplus
	return(input());
#else
	return(lex_input());
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyoutput(int c)
#else
yyoutput(c)
  int c; 
#endif
{
#ifndef __cplusplus
	output(c);
#else
	lex_output(c);
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyunput(int c)
#else
yyunput(c)
   int c; 
#endif
{
	unput(c);
	}
